classification
Title: test_shutil cross-file-system tests are fragile (may not test what they purport to test)
Type: behavior Stage: resolved
Components: Tests Versions: Python 3.4, Python 3.5, Python 2.7
process
Status: closed Resolution: out of date
Dependencies: Superseder:
Assigned To: Nosy List: BreamoreBoy, eric.araujo, jniehof, r.david.murray, serhiy.storchaka, tarek
Priority: normal Keywords:

Created on 2010-09-30 15:29 by r.david.murray, last changed 2018-12-12 09:25 by serhiy.storchaka. This issue is now closed.

Messages (5)
msg117744 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2010-09-30 15:29
In investigating issue 9993, I noticed that test_shutil wants to test things that require cross-file-system links, and arranges to have such links by creating a files and directories in the cwd and using tempfile.  Presumably the hope (and the comments make it clear it is a hope) is that frequently these will be different filesystems.  This is likely to be true on some systems (principally those that put /tmp on a memory file system), there is no guarantee that it is true for any system in the buildbot fleet (for example).

In addition, relatively recent changes to regrtest ensure that when the tests are run for an installed Python, the cwd is *guaranteed* to be in the same file system as things created by tempfile, since in that case the tempfile module is used by regrtest to run all tests in a temporary cwd.

It is this latter case that most concerns me and prompts this bug report, since a distribution should be able to reasonably expect that running the tests after installation (either real or sandboxed) should in fact test python on the target system.

Unfortunately I don't currently have a suggestion for how to reliably create a cross-file-system link for testing purposes.
msg117753 - (view) Author: Jonathan Niehof (jniehof) Date: 2010-09-30 17:01
Might it make sense to skip-decorate those tests which require cross-filesystem? Put a test above the TestMove definition which compares tempfile.gettempdir() and os.path.dirname(__file__).

I don't know of an out-of-the-box function to see if two paths are on the same filesystem; I suppose one approach would be to walk up the directory tree of each, checking ismount. (Looks like somebody's tried it: http://stackoverflow.com/questions/1138383/python-get-mount-point-on-windows-or-linux)
msg141965 - (view) Author: Éric Araujo (eric.araujo) * (Python committer) Date: 2011-08-12 16:08
> Unfortunately I don't currently have a suggestion for how to reliably
> create a cross-file-system link for testing purposes.

We could try walking a list of common mount points (/run, /dev, /tmp, /home, etc.), compiled from as many OSes as possible, and filter it with os.path.ismount to see if we have more than one partition.
msg221758 - (view) Author: Mark Lawrence (BreamoreBoy) * Date: 2014-06-28 00:57
Would you like to take this forward, or has it already happened but not been documented here?
msg331684 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2018-12-12 09:25
Starting from issue11560 test_shutil patches os.rename to imitate a failure in cross-file-system move.
History
Date User Action Args
2018-12-12 09:25:10serhiy.storchakasetstatus: open -> closed

nosy: + serhiy.storchaka
messages: + msg331684

resolution: out of date
stage: needs patch -> resolved
2014-06-28 00:57:35BreamoreBoysetnosy: + BreamoreBoy

messages: + msg221758
versions: + Python 3.4, Python 3.5, - Python 3.1, Python 3.2
2011-08-12 16:08:19eric.araujosetmessages: + msg141965
2010-11-02 21:08:07eric.araujosetnosy: + eric.araujo

title: test_shutil cross-file-system tests are fragile (may not test what they pruport to test) -> test_shutil cross-file-system tests are fragile (may not test what they purport to test)
2010-09-30 17:01:58jniehofsetnosy: + jniehof
messages: + msg117753
2010-09-30 15:29:09r.david.murraycreate